apiVersion: v1
kind: Pod  # Để phân loại loại tài nguyên, như chúng ta biết ngoài Pod thì có Deployment, Service...
metadata:  # Chứa thông tin metadata của Pod, có thể kể tới một số tham số chính như tên pod, label...
  name: "MYAPP"
  namespace: default
  labels:
    app: "MYAPP"
spec: # Đây là phần quan trọng nhất, nơi chứa các thông tin khai báo cho Pod và cho các Container trong Pod.
  hostAliases:  # Giống như ta khai báo host trong file /etc/hosts của máy chủ vậy. Nhưng ở đây ta khai báo cho Pod
    - ip: "127.0.0.1"
      hostnames:
        - "mylocalhost"
  
  initContainers: # Khai báo thông tin của initContainer (nếu có)
    - name: init-container-init-container
      image: busybox
      command: ['sh', '-c', "some-command-here"]
  containers: # Định nghĩa thông tin chi tiết cho các container của Pod.
  - name: container1
    image: busybox:latest
    resources:
      limits:
        cpu: 200m
        memory: 500Mi
      requests:
        cpu: 100m
        memory: 200Mi
    env:
    - name: DB_HOST
      valueFrom:
        configMapKeyRef:
          name: MYAPP
          key: DB_HOST
    ports:
    - containerPort:  80
      name:  http
    volumeMounts:
    - name: localtime
      mountPath: /etc/localtime
  volumes: # Khai báo Volume cho Pod. Volume có thể lấy từ configmap, từ PVC..
    - name: localtime
      hostPath:
        path: /usr/share/zoneinfo/Asia/Ho_Chi_Minh
  restartPolicy: Always # Có 3 giá trị là Always, OnFailure, và Never.
  affinity: # Là đối tượng khai báo các thuộc tính liên quan tới schedule Pod
    nodeAffinity: # NodeAffinity/NodeAntiaffinity - Định nghĩa việc lựa chọn/không lựa chọn triển khai Pod trên một Node theo tiêu chí nào đó. PodAffinity/PodAntiaffinity: Định nghĩa việc lựa chọn/không lựa chọn triển khai Pod trên một Node phụ thuộc vào một Pod nào đó
      requiredDuringSchedulingIgnoredDuringExecution:
        nodeSelectorTerms:
          - matchExpressions:
              - key: kubernetes.io/hostname
                operator: Exists

# Thông tin container name, image là bắt buộc
# spec -> container -> Khai báo container có tên là container1 từ image là busybox:latest
# spec -> env -> Khai báo biến môi trường tên là DB_HOST cho container được lấy giá trị từ một configmap tên là MYAPP và ở key có tên là DB_HOST
# spec -> ports -> Khai báo port của container là 80, port này được đặt tên là http
# spec -> volumeMounts -> Khai báo một phân vùng mount từ phân vùng localtime vào thư mục trong container là /etc/localtime

# Liệt kê các pod ở namespace mặc định -> kubectl get pods
# Hiện thị nhiều thông tin hơn -> kubectl get pod -o wide
# Hiện thị thông tin pod kèm label -> kubectl get pod -o wide --show-labels
# Pod ở namepace: kubernetes-dashboard -> kubectl get pod -o wide -n namespace-name
# Liệt kê các Pod có nhãn "app:pod-name" -> kubectl get pod -l "app=pod-name"
# Pod ở tất cả các namespace -> kubectl get pod -A

# Thông tin mô tả chi tiết của Pod -> kubectl describe pod/namepod

# Theo dõi log của Pod:
# Log của pod tên là pod-name -> kubectl logs pod/pod-name
# Log tất cả các Pod có label là app=pod-name -> kubectl logs -l "app=pod-name"

# Xóa pod theo tên -> kubectl delete pod/pod-name
# Xóa pod bằng chính file khai báo pod -> kubectl delete -f pod-name.yaml

# RUN: kubectl run {name_container} --image={image} --port={port}
# SHOW yaml: kubectl run {name_container} --image={image} --port={port} --dry-run=client -oyaml
# Record yaml: kubectl run {name_container} --image={image} --port={port} --dry-run=client -oyaml > {name_file}.yaml
